#ifndef QUICKMEDIA_NODE_SEARCH_H
#define QUICKMEDIA_NODE_SEARCH_H

#include <stddef.h>

#ifdef __cplusplus
extern "C" {
#endif

typedef struct {
    const char *data;
    size_t size;
} QuickMediaStringView;

typedef struct {
    QuickMediaStringView name;
    QuickMediaStringView value;
    int defined;
    int value_is_glob;
    int index; /* -1 if no indexing */
} QuickMediaNodeSearchParam;

typedef struct QuickMediaNodeSearch QuickMediaNodeSearch;

struct QuickMediaNodeSearch {
    QuickMediaStringView name; /* optional */
    int recursive;
    QuickMediaNodeSearchParam param; /* optional */
    QuickMediaNodeSearch *child; /* optional */
};

void quickmedia_node_search_param_init(QuickMediaNodeSearchParam *self);
void quickmedia_node_search_init(QuickMediaNodeSearch *self);
void quickmedia_node_search_deinit(QuickMediaNodeSearch *self);

#ifdef __cplusplus
}
#endif

#endif
