#include "../include/quickmedia/NodeSearch.h"
#include <stdlib.h>

void quickmedia_node_search_param_init(QuickMediaNodeSearchParam *self) {
    self->name.data = NULL;
    self->name.size = 0;
    self->value.data = NULL;
    self->value.size = 0;
    self->defined = 0;
    self->value_is_glob = 0;
    self->index = -1;
}

static void quickmedia_node_search_param_deinit(QuickMediaNodeSearchParam *self) {
    quickmedia_node_search_param_init(self);
}

void quickmedia_node_search_init(QuickMediaNodeSearch *self) {
    self->name.data = NULL;
    self->name.size = 0;
    self->recursive = 0;
    quickmedia_node_search_param_init(&self->param);
    self->child = NULL;
}

void quickmedia_node_search_deinit(QuickMediaNodeSearch *self) {
    self->name.data = NULL;
    self->name.size = 0;
    quickmedia_node_search_param_deinit(&self->param);
    
    if(self->child) {
        quickmedia_node_search_deinit(self->child);
        free(self->child);
        self->child = NULL;
    }
}
